lib = File.expand_path("../lib", __FILE__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)

require "./lib/eco/version"

Gem::Specification.new do |spec|
  spec.name          = "eco-helpers"
  spec.version       = Eco::VERSION
  spec.platform      = Gem::Platform::RUBY
  spec.authors       = ["Oscar Segura"]
  spec.email         = ["oscar@ecoportal.co.nz"]
  spec.date          = %q{2018-09-05}
  spec.summary       = %q{eco-helpers to manage people api cases}
  spec.homepage      = "https://www.ecoportal.com"
  spec.licenses      = %w[MIT]

  spec.required_ruby_version = '>= 2.5.0'

  spec.files         = `git ls-files -z`.split("\x0").reject do |f|
    f.match(%r{^(test|spec|features)/})
  end

  #spec.test_files    = `git ls-files -- {test,spec,features}/*`.split("\n")
  #spec.executables   = `git ls-files -- bin/*`.split("\n").map{ |f| File.basename(f) }
  spec.require_paths = ["lib"]

  spec.add_development_dependency "bundler",   ">= 2.2.17",  "< 2.3"
  spec.add_development_dependency "rspec",     ">= 3.10.0", "< 3.11"
  spec.add_development_dependency "rake",      ">= 13.0.3", "< 13.1"
  spec.add_development_dependency "yard",      ">= 0.9.26", "< 0.10"
  spec.add_development_dependency "redcarpet", ">= 3.5.1",  "< 3.6"

  spec.add_dependency 'ecoportal-api', '>= 0.8.3', '< 0.9'
  spec.add_dependency 'ecoportal-api-v2', '>= 0.8.13', '< 0.9'
  spec.add_dependency 'aws-sdk-s3',    '>= 1.83.0', '< 2'
  spec.add_dependency 'aws-sdk-ses',   '>= 1.36.0', '< 2'
  spec.add_dependency 'dotenv',        '>= 2.7.6', '< 2.8'
  spec.add_dependency 'net-sftp',      '>= 3.0.0', '< 3.1'
  spec.add_dependency 'hashdiff',      '>= 1.0.1', '< 1.1'
  spec.add_dependency 'fuzzy_match',   '>= 2.1.0', '< 2.2'
  spec.add_dependency 'amatch',        '>= 0.4.0', '< 0.5'
  spec.add_dependency 'jaro_winkler',  '>= 1.5.4', '< 1.6'
  spec.add_dependency 'roo',           '>= 2.8.3', '< 2.9'
  spec.add_dependency 'roo-xls',       '>= 1.2.0', '< 1.3'
  spec.add_dependency 'docx',          '>= 0.6.2', '< 0.7'
end
